#################################################################
# Makefile generated by Xilinx Platform Studio 
# Project:\\fenphen\satish\DevArea\MP3Decoder\MAD_MP3\MicroBlaze_Version_EDK611_OPT_MAD_HW_DCT32_HW_IMDCT_HW_MADMUL\system.xmp
#################################################################

include system_incl.make

# Name of the Microprocessor system
# The hardware specification of the system is in file :
# \\fenphen\satish\DevArea\MP3Decoder\MAD_MP3\MicroBlaze_Version_EDK611_OPT_MAD_HW_DCT32_HW_IMDCT_HW_MADMUL\system.mhs
# The software specification of the system is in file :
# \\fenphen\satish\DevArea\MP3Decoder\MAD_MP3\MicroBlaze_Version_EDK611_OPT_MAD_HW_DCT32_HW_IMDCT_HW_MADMUL\system.mss

#SYSTEM = system
#
#MHSFILE = system.mhs
#
#MSSFILE = system.mss
#
#FPGA_ARCH = virtex2
#
#DEVICE = xc2v2000ff896-4
#
#LANGUAGE = vhdl
#
#SEARCHPATHOPT = 
#
#PLATGEN_OPTIONS = -p $(DEVICE) -lang $(LANGUAGE) $(SEARCHPATHOPT) 
#
#LIBGEN_OPTIONS = -mhs $(MHSFILE) -p $(FPGA_ARCH) $(SEARCHPATHOPT) \
#                   $(MY_BLAZE_LIBG_OPT)
#
#SIM_CMD = vsim
#
#BEHAVIORAL_SIM_SCRIPT = simulation/behavioral/$(SYSTEM).do
#
#STRUCTURAL_SIM_SCRIPT = simulation/structural/$(SYSTEM).do
#
#TIMING_SIM_SCRIPT = simulation/timing/$(SYSTEM).do
#
#DEFAULT_SIM_SIM_SCRIPT = $(BEHAVIORAL_SIM_SCRIPT)
#
#SIMGEN_OPTIONS = -p $(FPGA_ARCH) -lang $(LANGUAGE) $(SEARCHPATHOPT) -s mti -X C:/MSE57E -E C:/MSE57E/edklib
#
MY_BLAZE_OUTPUT = my_blaze/code/executable.elf
#MY_BLAZE_XMDSTUB = my_blaze/code/xmdstub.elf
MY_BOOTLOOP = bootloop/bootloop.elf

#LIBRARIES =  \
#       my_blaze/lib/libxil.a 


#################################################################
# EXTERNAL TARGETS
#################################################################
all:
	@echo "Makefile to build a Microprocessor system :"
	@echo "Run make with any of the following targets"
	@echo " "
	@echo "  netlist  : Generates the netlist for the given MHS "
	@echo "  bits     : Runs Implementation tools to generate the bitstream"
	@echo "  exporttopn:Export to ProjNav"
	@echo " "
	@echo "  libs     : Configures the sw libraries for this system"
	@echo "  program  : Compiles the program sources for all the processor instances"
	@echo "  bsp      : Generate a bsp for vxworks"
	@echo " "
	@echo "  init_bram: Initializes bitstream with BRAM data"
	@echo "  ace      : Generate ace file from bitstream and elf"
	@echo "  download : Downloads the bitstream onto the board"
	@echo " "
	@echo "  sim      : Generates HDL simulation models and runs simulator for chosen simulation mode"
	@echo "  simmodel : Generates HDL simulation models for chosen simulation mode"
	@echo "  behavioral:Generates behavioral HDL models with BRAM initialization"
	@echo "  structural:Generates structural simulation HDL models with BRAM initialization"
	@echo "  timing   : Generates timing simulation HDL models with BRAM initialization"
	@echo " "
	@echo "  netlistclean: Deletes netlist"
	@echo "  bigsclean: Deletes bit, ncd, bmm files"
	@echo "  hwclean  : Deletes implementation dir"
	@echo "  libsclean: Deletes sw libraries"
	@echo "  programclean: Deletes compiled ELF files"
	@echo "  swclean  : Deletes sw libraries and ELF files"
	@echo "  simclean : Deletes simulation dir"
	@echo "  clean    : Deletes all generated files/directories"
	@echo " "
	@echo "  make <target> : (Default)"
	@echo "      Creates a Microprocessor system using default initializations"
	@echo "      specified for each processor in MSS file"


bits: implementation/$(SYSTEM).bit

ace: implementation/$(SYSTEM).ace

netlist: implementation/$(SYSTEM).ngc

libs: $(LIBRARIES)

program: $(MY_BLAZE_OUTPUT) 

bsp: 
	@echo "To generate BSP, please specify VxWorks5_4/VxWorks5_5 as OS for atleast one PPC405 instance"

download: implementation/download.bit dummy
	@echo "*********************************************"
	@echo "Downloading Bitstream onto the target board"
	@echo "*********************************************"
	impact -batch etc/download.cmd

init_bram: implementation/download.bit

sim: $(DEFAULT_SIM_SIM_SCRIPT)
	cd simulation/behavioral; \
	$(SIM_CMD) -do $(SYSTEM).do &

simmodel: $(DEFAULT_SIM_SIM_SCRIPT)

behavioral_model: $(BEHAVIORAL_SIM_SCRIPT)

structural_model: $(STRUCTURAL_SIM_SCRIPT)

timing_model: $(TIMING_SIM_SCRIPT)

clean: hwclean libsclean programclean simclean
	rm -f _impact.cmd

hwclean: netlistclean bitsclean
	rm -rf implementation synthesis xst hdl
	rm -rf xst.srp $(SYSTEM).srp

netlistclean:
	rm -f implementation/$(SYSTEM).ngc

bitsclean:
	rm -f implementation/$(SYSTEM).bit
	rm -f implementation/$(SYSTEM).ncd
	rm -f implementation/$(SYSTEM)_bd.bmm 

bitsclean:

simclean: 
	rm -rf simulation/behavioral

swclean: libsclean programclean
	@echo ""

libsclean: MY_BLAZE_LIBSCLEAN 

programclean: MY_BLAZE_PROGRAMCLEAN 

#################################################################
# TARGETS/MACROS FOR PROCESSOR MY_BLAZE
#################################################################

MY_BLAZE_SOURCES = code/synth.c code/bit.c code/frame.c code/huffman.c code/layer3.c code/madlld.c code/stream.c code/sound_controller.c 

MY_BLAZE_HEADERS = code/stream.h code/synth.h code/bit.h code/config.h code/dct32_constants.h code/fixed.h code/frame.h code/global.h code/huffman.h code/layer3.h code/mad.h code/imdct_constants.h 

MY_BLAZE_CC = mb-gcc
MY_BLAZE_CC_SIZE = mb-size
MY_BLAZE_CC_OPT = -O2
MY_BLAZE_CFLAGS = -mxl-barrel-shift -mno-xl-soft-mul -mno-xl-soft-div -DHARDWARE_VERSION
#MY_BLAZE_CFLAGS = -mxl-barrel-shift -mno-xl-soft-mul -mno-xl-soft-div -DHARDWARE_VERSION -DNO_PLAY
#MY_BLAZE_CFLAGS = -mxl-barrel-shift -mno-xl-soft-mul -mno-xl-soft-div 
MY_BLAZE_CC_SEARCH = # -B
MY_BLAZE_LIBPATH = -L./my_blaze/lib/ # -L
MY_BLAZE_INCLUDES = -I./my_blaze/include/  -Icode/ # -I
MY_BLAZE_LFLAGS = # -l

MY_BLAZE_CC_FLOW =  # -[E|S|c]
MY_BLAZE_CC_PREPROC_FLAG = # -Wp,
MY_BLAZE_CC_ASM_FLAG = # -Wa,
MY_BLAZE_CC_LINKER_FLAG = # -Wl,
MY_BLAZE_LINKER_SCRIPT = -Wl,-T -Wl,code/linker_script
MY_BLAZE_CC_DEBUG_FLAG =  -g 
MY_BLAZE_CC_GLOBPTR_FLAG= # -mxl-gp-opt
MY_BLAZE_MODE = executable
MY_BLAZE_LIBG_OPT = #-$(MY_BLAZE_MODE) my_blaze MODIFICATION FOR EDK 6.3!
MY_BLAZE_CC_SOFTMUL_FLAG= -mno-xl-soft-mul 
MY_BLAZE_CC_START_ADDR_FLAG=  # -Wl,-defsym -Wl,_TEXT_START_ADDR=
MY_BLAZE_CC_STACK_SIZE_FLAG=  -Wl,-defsym -Wl,_STACK_SIZE=0x30000
MY_BLAZE_OTHER_CC_FLAGS= $(MY_BLAZE_CC_FLOW) $(MY_BLAZE_CC_GLOBPTR_FLAG)  \
                  $(MY_BLAZE_CC_START_ADDR_FLAG) $(MY_BLAZE_CC_STACK_SIZE_FLAG)  \
                  $(MY_BLAZE_CC_SOFTMUL_FLAG)  -mxl-barrel-shift -mno-xl-soft-div \
                  $(MY_BLAZE_CC_PREPROC_FLAG) $(MY_BLAZE_CC_ASM_FLAG) $(MY_BLAZE_CC_LINKER_FLAG)  \
                  $(MY_BLAZE_LINKER_SCRIPT) $(MY_BLAZE_CC_DEBUG_FLAG) 

$(MY_BLAZE_OUTPUT) : $(MY_BLAZE_SOURCES) $(MY_BLAZE_HEADERS) $(LIBRARIES) __xps/my_blaze_compiler.opt code/linker_script
	$(MY_BLAZE_CC) $(MY_BLAZE_CFLAGS) $(MY_BLAZE_CC_OPT) $(MY_BLAZE_SOURCES) -o $(MY_BLAZE_OUTPUT)  \
	$(MY_BLAZE_OTHER_CC_FLAGS) $(MY_BLAZE_INCLUDES) $(MY_BLAZE_LIBPATH)  \
	-xl-mode-$(MY_BLAZE_MODE)  \
	$(MY_BLAZE_LFLAGS) 
	$(MY_BLAZE_CC_SIZE) $(MY_BLAZE_OUTPUT) 

MY_BLAZE_LIBSCLEAN:
	rm -rf my_blaze/lib/

MY_BLAZE_PROGRAMCLEAN:
	rm -f $(MY_BLAZE_OUTPUT) 

#################################################################
# TARGETS/MACROS FOR XILINX IMPLEMENTATION FLOW
#################################################################


implementation/download.bit: implementation/$(SYSTEM).bit  $(MY_BLAZE_OUTPUT) 
	@cp -f implementation/$(SYSTEM)_bd.bmm .
	@echo "*********************************************"
	@echo "Initializing BRAM contents of the bitstream"
	@echo "*********************************************"
	bitinit $(MHSFILE) $(SEARCHPATHOPT)  -pe my_blaze $(MY_BOOTLOOP)  -bt implementation/$(SYSTEM).bit -o implementation/download.bit
	@rm -f $(SYSTEM)_bd.bmm

implementation/$(SYSTEM).bit: implementation/$(SYSTEM).ngc etc/fast_runtime.opt __xps/xpsxflow.opt data/$(SYSTEM).ucf etc/bitgen.ut
	@echo "Copying Xilinx Implementation tool scripts.."
	@cp -f etc/bitgen.ut implementation/bitgen.ut
	@cp -f etc/fast_runtime.opt implementation/
	@cp -f data/$(SYSTEM).ucf implementation/$(SYSTEM).ucf
	@echo "*********************************************"
	@echo "Running Xilinx Implementation tools.."
	@echo "*********************************************"
	xflow -wd implementation -p $(DEVICE) -implement fast_runtime.opt $(SYSTEM).ngc
	cd implementation; bitgen -w -f bitgen.ut $(SYSTEM)

exporttopn: 
	@echo You have chosen XPS for implementation tool flow.
	@echo Please select ProjNav as your implementation flow in Project Options or use commad xset pnproj <nplfile> in batch mode

implementation/$(SYSTEM).ace:
	@echo "You must have exactly one ppc405 to generate ace file"

implementation/$(SYSTEM).ngc implementation/$(SYSTEM).bmm: \
$(MHSFILE) __xps/platgen.opt
	@echo "*********************************************"
	@echo "Creating system netlist for hardware specification.."
	@echo "*********************************************"
	platgen $(PLATGEN_OPTIONS) -st xst  $(MHSFILE)
	@echo "Running synthesis..."
	bash -c "cd synthesis; ./synthesis.sh; cd .."

$(LIBRARIES): $(MHSFILE) $(MSSFILE) __xps/libgen.opt
	@echo "*********************************************"
	@echo "Creating software libraries..."
	@echo "*********************************************"
	libgen $(LIBGEN_OPTIONS) $(MSSFILE)

#################################################################
# TARGETS/MACROS FOR SIMULATION FLOW
#################################################################


$(BEHAVIORAL_SIM_SCRIPT): $(MHSFILE) __xps/simgen.opt \
 $(MY_BLAZE_OUTPUT) 
	@echo "*********************************************"
	@echo "Creating behavioral simulation models..."
	@echo "*********************************************"
	simgen $(SIMGEN_OPTIONS) -m behavioral $(MHSFILE)  -pe my_blaze $(MY_BLAZE_OUTPUT) 

$(STRUCTURAL_SIM_SCRIPT): $(MHSFILE) __xps/simgen.opt \
 $(MY_BLAZE_OUTPUT)  \
implementation/clk_50_bufg_wrapper.ngc \
implementation/main_dcm_wrapper.ngc \
implementation/sys_clk_bufg_wrapper.ngc \
implementation/zbt_dcm_wrapper.ngc \
implementation/myopb_bus_wrapper.ngc \
implementation/my_blaze_wrapper.ngc \
implementation/my_intc_wrapper.ngc \
implementation/my_mdm_wrapper.ngc \
implementation/my_zbt_wrapper.ngc \
implementation/my_zbt_2_wrapper.ngc \
implementation/islmb_wrapper.ngc \
implementation/dslmb_wrapper.ngc \
implementation/d_lmb_wrapper.ngc \
implementation/i_lmb_wrapper.ngc \
implementation/lmblmb_bram_i_wrapper.ngc \
implementation/from_mb_fsl_1_wrapper.ngc \
implementation/to_mb_fsl_1_wrapper.ngc \
implementation/my_dct32_wrapper.ngc \
implementation/from_mb_fsl_2_wrapper.ngc \
implementation/to_mb_fsl_2_wrapper.ngc \
implementation/my_imdct_wrapper.ngc \
implementation/from_mb_fsl_3_wrapper.ngc \
implementation/to_mb_fsl_3_wrapper.ngc \
implementation/my_mp3_mul_28_wrapper.ngc \
implementation/from_mb_fsl_4_wrapper.ngc \
implementation/to_mb_fsl_4_wrapper.ngc \
implementation/my_mp3_mul_16_wrapper.ngc
	@echo "*********************************************"
	@echo "Creating structural simulation models..."
	@echo "*********************************************"
	simgen $(SIMGEN_OPTIONS) -sd implementation -m structural $(MHSFILE)  -pe my_blaze $(MY_BLAZE_OUTPUT) 

$(TIMING_SIM_SCRIPT): $(MHSFILE) __xps/simgen.opt \
 $(MY_BLAZE_OUTPUT)  \
implementation/$(SYSTEM).bit
	@echo "*********************************************"
	@echo "Creating timing simulation models..."
	@echo "*********************************************"
	simgen $(SIMGEN_OPTIONS) -sd implementation -m timing $(MHSFILE)  -pe my_blaze $(MY_BLAZE_OUTPUT) 


implementation/clk_50_bufg_wrapper.ngc \
implementation/main_dcm_wrapper.ngc \
implementation/sys_clk_bufg_wrapper.ngc \
implementation/zbt_dcm_wrapper.ngc \
implementation/myopb_bus_wrapper.ngc \
implementation/my_blaze_wrapper.ngc \
implementation/my_intc_wrapper.ngc \
implementation/my_mdm_wrapper.ngc \
implementation/my_zbt_wrapper.ngc \
implementation/my_zbt_2_wrapper.ngc \
implementation/islmb_wrapper.ngc \
implementation/dslmb_wrapper.ngc \
implementation/d_lmb_wrapper.ngc \
implementation/i_lmb_wrapper.ngc \
implementation/lmblmb_bram_i_wrapper.ngc \
implementation/from_mb_fsl_1_wrapper.ngc \
implementation/to_mb_fsl_1_wrapper.ngc \
implementation/my_dct32_wrapper.ngc \
implementation/from_mb_fsl_2_wrapper.ngc \
implementation/to_mb_fsl_2_wrapper.ngc \
implementation/my_imdct_wrapper.ngc \
implementation/from_mb_fsl_3_wrapper.ngc \
implementation/to_mb_fsl_3_wrapper.ngc \
implementation/my_mp3_mul_28_wrapper.ngc \
implementation/from_mb_fsl_4_wrapper.ngc \
implementation/to_mb_fsl_4_wrapper.ngc \
implementation/my_mp3_mul_16_wrapper.ngc:
	platgen $(PLATGEN_OPTIONS) $(MHSFILE)

dummy:
	@echo ""

